<?php

# check if session is valid
$newTarget = '/app/berogui/index.php?m=Dialplan';
require_once('/usr/local/www/berogui/includes/session.php');
unset($newTarget);


chdir("../..");
include './includes/variables.php';
require_once "./includes/Helper/Helper.php";
include './misc/database.php';
$ba = new beroAri();
require_once ('./includes/lang.php');
//AJAX um die Haupseite zu aktualisieren
echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">
<html>
<head>";

function fromSip($reverse=0){
	$fromid = $_POST['fromIdSip'];
	$match_type = $_POST['matchType'];
	$fromManual = trim($_POST['manualsipfrom']);
	
	switch ($match_type) {
		case "manual":
			$fromid = $fromManual;
			break;
		case "any":
			$fromid = ".*";
			break;
		default:
			($reverse==1) ? $fromid = "p:" . $fromid : $fromid = $match_type . $fromid;
			break;
	}
	
	return $fromid;
}


$page = $_POST['start'];
$dir = $_POST['dir'];
$search = $_POST['search'];

$fromDirection = $_POST['fromDirection'];
$toDirection = $_POST['toDirection'];
$dest = trim($_POST['dest']);
$newdest = trim($_POST['newDest']);
$src = trim($_POST['src']);
$newsrc = trim($_POST['newSrc']);
$comment = trim($_POST['comment']);
(isset($_POST['activ'])) ? $activ = 1 : $activ = 0;
$toid = $_POST['to' . ucwords($toDirection)];
$toManual = trim($_POST['manual' . $toDirection]);

if ($toid == "manual")
	$toid = $toManual;

//Update a dial plan rule
if (isset($_POST['id_upd'])) {
	$query = $ba->select("select * from dialplan WHERE id='" . sqlite_escape_string($_POST['id_upd']) . "'");
	$result = array();
	while ($entry = $ba->fetch_array($query)) {
		$result['fromDirection'] = $entry['fromDirection'];
		$result['toDirection'] = $entry['toDirection'];
	}

	$id = $_POST['id_upd'];
	$default = false;
	//Set the config to default if the direction changes
	if ($result['fromDirection'] != $fromDirection || $result['toDirection'] != $toDirection) {
		$default = true;
	}
	if ($default)
		$config = '';
	else
		$config = $_POST['config'];
	//From SIP direction
	if ($fromDirection == 'sip') {
		$fromid = fromSip();

		$query_new = $ba->update("UPDATE dialplan SET fromDirection='" . sqlite_escape_string($fromDirection) . "', toDirection='" . sqlite_escape_string($toDirection) . "', fromId='" . sqlite_escape_string($fromid) . "', toId='" . sqlite_escape_string($toid) . "', dest='" . sqlite_escape_string($dest) . "', newDest='" . sqlite_escape_string($newdest) . "', src='" . sqlite_escape_string($src) . "', newSrc='" . sqlite_escape_string($newsrc) . "', comment='" . sqlite_escape_string($comment) . "', activ='" . sqlite_escape_string($activ) . "', config='" . sqlite_escape_string($config) . "', isdnid='' WHERE id='".sqlite_escape_string($id)."'");
	}

	//From PSTN direction
	if ($fromDirection == 'isdn' || $fromDirection == 'analog' || $fromDirection == 'gsm' || $fromDirection == 'lte' || $fromDirection == 'cas') {
		$fromid = $_POST['fromId' . ucwords($fromDirection)];
		$fromManual = trim($_POST['manual' . $fromDirection . 'from']);

		if ($fromid == "manual")
			$fromid = $fromManual;

		//Default config für ISDN to ISDN
		if ($fromDirection == "isdn" && $toDirection == "isdn" && $default === true)
			$config = "ie_on_sip=1,ec=0,t38=0,unknownprefix=,internationalprefix=,nationalprefix=,privateprefix=,localprefix=";

		//From PSTN to PSTN
		if (($fromDirection == 'isdn' || $fromDirection == 'analog' || $fromDirection == 'gsm' || $fromDirection == 'lte' || $fromDirection == 'cas') 
			&& ($toDirection == 'isdn' || $toDirection == 'analog' || $toDirection == 'gsm' || $toDirection == 'lte' || $toDirection == 'cas')) {
			if ($_POST['isdnid'] != "") {
				$qu = $ba->update("UPDATE dialplan SET fromDirection='" . sqlite_escape_string($fromDirection) . "', toDirection='" . sqlite_escape_string($toDirection) . "', fromId='" . sqlite_escape_string($fromid) . "', toId='" . sqlite_escape_string($toid) . "', dest='" . sqlite_escape_string($dest) . "', newDest='" . sqlite_escape_string($newdest) . "', src='" . sqlite_escape_string($src) . "', newSrc='" . sqlite_escape_string($newsrc) . "', comment='" . sqlite_escape_string($comment) . "', config='" . sqlite_escape_string($config) . "', activ='" . sqlite_escape_string($activ) . "'  WHERE isdnid='" . sqlite_escape_string($_POST['isdnid']) . "'");
			} else {
				//Unique id erzeuge als isdnid
				$isdnid = uniqid("ISDNZUISDN");
				$qu = $ba->update("UPDATE dialplan SET fromDirection='" . sqlite_escape_string($fromDirection) . "', toDirection='" . sqlite_escape_string($toDirection) . "', fromId='" . sqlite_escape_string($fromid) . "', toId='" . sqlite_escape_string($toid) . "', dest='" . sqlite_escape_string($dest) . "', newDest='" . sqlite_escape_string($newdest) . "', src='" . sqlite_escape_string($src) . "', newSrc='" . sqlite_escape_string($newsrc) . "', isdnid='" . sqlite_escape_string($isdnid) . "', comment='" . sqlite_escape_string($comment) . "', config='" . sqlite_escape_string($config) . "', activ='" . sqlite_escape_string($activ) . "'  WHERE id='" . sqlite_escape_string($id) . "'");
			}
		//From PSTN to SIP	
		} else {
			$qu = $ba->update("UPDATE dialplan SET fromDirection='" . sqlite_escape_string($fromDirection) . "', toDirection='" . sqlite_escape_string($toDirection) . "', fromId='" . sqlite_escape_string($fromid) . "', toId='" . sqlite_escape_string($toid) . "', dest='" . sqlite_escape_string($dest) . "', newDest='" . sqlite_escape_string($newdest) . "', src='" . sqlite_escape_string($src) . "', newSrc='" . sqlite_escape_string($newsrc) . "', comment='" . sqlite_escape_string($comment) . "', activ='" . sqlite_escape_string($activ) . "', config='" . sqlite_escape_string($config) . "', isdnid='' WHERE id='".sqlite_escape_string($id)."'");
		}
	}
//Create a new dial plan rule
} else {
	$config = $_POST['config'];
	$reverse = $_POST['reverse'];
	if ($dest == "") {
		$dest = "(.*)";
	}
	if ($newdest == "") {
		$newdest = "\\\\1";
	}
	if ($src == "") {
		$src = "(.*)";
	}
	if ($newsrc == "") {
		$newsrc = "\\\\1";
	}
	$q = $ba->select("select max(posId) from dialplan");
	$posId = sqlite_fetch_single($q) + 1;

	//From SIP direction
	if ($fromDirection == 'sip') {
		$origFromid = $_POST['fromIdSip'];
		$fromid=  fromSip();
		
		$query_new = $ba->insert_("INSERT INTO dialplan (fromDirection, toDirection, fromId, toId, dest, newDest, src, newSrc, posId, comment, config, activ) VALUES ('" . sqlite_escape_string($fromDirection) . "','" . sqlite_escape_string($toDirection) . "','" . sqlite_escape_string($fromid) . "','" . sqlite_escape_string($toid) . "', '" . sqlite_escape_string($dest) . "', '" . sqlite_escape_string($newdest) . "', '" . sqlite_escape_string($src) . "', '" . sqlite_escape_string($newsrc) . "',  '" . sqlite_escape_string($posId) . "', '" . sqlite_escape_string($comment) . "', '" . sqlite_escape_string($config) . "', '" . sqlite_escape_string($activ) . "')");
		//Create reverse rule
		if ($reverse==1){
			$toidRev = fromSip(1);
			$dest = "(.*)";
			$newdest = "\\\\1";
			$src = "(.*)";
			$newsrc = "\\\\1";
			$query_new = $ba->insert_("INSERT INTO dialplan (fromDirection, toDirection, fromId, toId, dest, newDest, src, newSrc, posId, comment, config, activ) VALUES ('" . sqlite_escape_string($toDirection) . "','" . sqlite_escape_string($fromDirection) . "','" . sqlite_escape_string($toid) . "','" . sqlite_escape_string($toidRev) . "', '" . sqlite_escape_string($dest) . "', '" . sqlite_escape_string($newdest) . "', '" . sqlite_escape_string($src) . "', '" . sqlite_escape_string($newsrc) . "',  '" . sqlite_escape_string($posId+1) . "', '" . sqlite_escape_string($comment) . "', '" . sqlite_escape_string($config) . "', '" . sqlite_escape_string($activ) . "')");
		}
		
	}

	//From PSTN direction
	if ($fromDirection == 'isdn' || $fromDirection == 'analog' || $fromDirection == 'gsm' || $fromDirection == 'lte' || $fromDirection == 'cas') {
		$fromid = $_POST['fromId' . ucwords($fromDirection)];
		$fromManual = trim($_POST['manual' . $fromDirection . 'from']);

		if ($fromid == "manual")
			$fromid = $fromManual;
		if ($fromDirection == "isdn" && $toDirection == "isdn")
			$config.="ie_on_sip=1,ec=0,t38=0,unknownprefix=,internationalprefix=,nationalprefix=,privateprefix=,localprefix=";

		//PSTN to PSTN
		if (($fromDirection == 'isdn' || $fromDirection == 'analog' || $fromDirection == 'gsm' || $fromDirection == 'lte' || $fromDirection == 'cas') 
			&& ($toDirection == 'isdn' || $toDirection == 'analog' || $toDirection == 'gsm' || $toDirection == 'lte' || $toDirection == 'cas')) {
			$isdnid = uniqid("ISDNZUISDN");
			$ba->insert_("insert into dialplan (fromDirection, toDirection,fromId, toId, dest, newDest, src, newSrc, isdnid, posId, comment, config, activ) VALUES ('" . sqlite_escape_string($fromDirection) . "', '" . sqlite_escape_string($toDirection) . "', '" . sqlite_escape_string($fromid) . "', '" . sqlite_escape_string($toid) . "', '" . sqlite_escape_string($dest) . "', '" . sqlite_escape_string($newdest) . "', '" . sqlite_escape_string($src) . "', '" . sqlite_escape_string($newsrc) . "', '" . sqlite_escape_string($isdnid) . "','" . sqlite_escape_string($posId) . "', '" . sqlite_escape_string($comment) . "', '" . sqlite_escape_string($config) . "', '" . sqlite_escape_string($activ) . "')");
		//PSTN to SIP	
		} else {
			$ba->insert_("insert into dialplan (fromDirection, toDirection,fromId, toId, dest, newDest, src, newSrc, posId, comment, config, activ) VALUES ('" . sqlite_escape_string($fromDirection) . "', '" . sqlite_escape_string($toDirection) . "', '" . sqlite_escape_string($fromid) . "', '" . sqlite_escape_string($toid) . "', '" . sqlite_escape_string($dest) . "', '" . sqlite_escape_string($newdest) . "', '" . sqlite_escape_string($src) . "', '" . sqlite_escape_string($newsrc) . "','" . sqlite_escape_string($posId) . "', '" . sqlite_escape_string($comment) . "', '" . sqlite_escape_string($config) . "', '" . sqlite_escape_string($activ) . "')");
		}
		//Create reverse rule
		if ($reverse==1){
			$dest = "(.*)";
			$newdest = "\\\\1";
			$src = "(.*)";
			$newsrc = "\\\\1";
			//PSTN to PSTN
			if (($fromDirection == 'isdn' || $fromDirection == 'analog' || $fromDirection == 'gsm' || $fromDirection == 'lte' || $fromDirection == 'cas') 
				&& ($toDirection == 'isdn' || $toDirection == 'analog' || $toDirection == 'gsm' || $toDirection == 'lte' || $toDirection == 'cas')) {
				$isdnid = uniqid("ISDNZUISDN");
				$ba->insert_("insert into dialplan (fromDirection, toDirection,fromId, toId, dest, newDest, src, newSrc, isdnid, posId, comment, config, activ) VALUES ('" . sqlite_escape_string($toDirection) . "', '" . sqlite_escape_string($fromDirection) . "', '" . sqlite_escape_string($toid) . "', '" . sqlite_escape_string($fromid) . "', '" . sqlite_escape_string($dest) . "', '" . sqlite_escape_string($newdest) . "', '" . sqlite_escape_string($src) . "', '" . sqlite_escape_string($newsrc) . "', '" . sqlite_escape_string($isdnid) . "','" . sqlite_escape_string($posId+1) . "', '" . sqlite_escape_string($comment) . "', '" . sqlite_escape_string($config) . "', '" . sqlite_escape_string($activ) . "')");
			//SIP to PSTN	
			} else {
				//Set Matchtype a: for Sip accounts
				$toid= preg_replace('/^(p:)/', 'a:', $toid);
				$ba->insert_("insert into dialplan (fromDirection, toDirection,fromId, toId, dest, newDest, src, newSrc, posId, comment, config, activ) VALUES ('" . sqlite_escape_string($toDirection) . "', '" . sqlite_escape_string($fromDirection) . "', '" . sqlite_escape_string($toid) . "', '" . sqlite_escape_string($fromid) . "', '" . sqlite_escape_string($dest) . "', '" . sqlite_escape_string($newdest) . "', '" . sqlite_escape_string($src) . "', '" . sqlite_escape_string($newsrc) . "','" . sqlite_escape_string($posId+1) . "', '" . sqlite_escape_string($comment) . "', '" . sqlite_escape_string($config) . "', '" . sqlite_escape_string($activ) . "')");
			}
		}
	}

	if (isset($_POST['first']) && !$ba->is_error()) {
		$q = $ba->select("select max(id) from dialplan");
		$id = sqlite_fetch_single($q);
		if ($reverse==1)
			echo "<script>window.location='./change_pos.php?posid=1&id[]=" . $id . "&id[]=".($id-1)."&first=1';</script>";
		else
			echo "<script>window.location='./change_pos.php?posid=1&id[]=" . $id . "&first=1';</script>";
	}
}
Helper::activate(1);

if (!$ba->is_error()) {
	$page = $_POST['start'];
	$dir = $_POST['dir'];
	$search = $_POST['search'];
	echo "<script>window.location='../../index.php?m=Dialplan&start=" . $page . "&dir=" . $dir . "&search=" . $search . "';</script>";
} else {
	echo "<script>alert('" . $ba->error() . "');</script>";
}
?>